#pragma once
#define THREAD_HEART 500
#define NUMBER_LENGTH 10
#define NUMBER_SIGIN_LENGTH 22
#define SCANF_TIME_OUT 30

class CGameTool
{
public:
	CGameTool(void);
	~CGameTool(void);
	void startWork();
	void stopWork();
	BOOL isWorking();
	void releaseHwnd();
	void sleep(int Milliseconds);
	CString  getTimeFileName();
	CString  getFomatTime();
	HDC getGameHdc();
	BOOL setGameHwnd(HWND hwnd);
	HWND getGameHwnd();
	HWND findFlashHwnd(HWND ParentWnd);
	HWND findWithClassName(HWND ParentWnd,CString wName);
	void updatePixel();
	int findNumberWidthColor(int x,int y,int w,int h,int color);
	CPoint findPointFromColor(int x,int y,int w,int h,int color);
	COLORREF getColor(int x,int y);
	COLORREF getCurColor(int x,int y);
	void getColors(int x,int y,int w,int h,int *colors);
	void getCurColors(int x,int y,int w,int h,int *colors);
	COLORREF getPixel(int x,int y);
	int ident(CString trait,CString libTrait[]);
	float identFloat(CString trait,CString libTrait[]);
	void identSign(CString trait,CString libTrait[],int *outArray);
	CString scanfTrait(int x,int y,int w,int h,int dissolve);
	CString scanfTraitByColor(int x,int y,int w,int h,int color);
	BOOL colorDissolve(int color,int dissolve);
	void int2rgb(int color,int *oColor);
	int rgb2int(int r, int g, int b);
	int converColor(int color);
	CString getSubString(CString str1, CString str2);
	void tokenize(CString text,CString split,CArray<CString> *list);
	BOOL compare(COLORREF src,COLORREF dst);
	int sort(int data[],int length);
	void sendMouseClick(long x,long y);
	void sendMouseClick_Random(long x,long y);
	BOOL doCheck(int eventArray[]);
	BOOL doCheck(int eventArray[],int sleepTime);
	BOOL waitForLoad(int colorArray[]);
	void captureScreen();
	void copyToClip(CString text);
	void captureData();
	void checkScreenBits();
	void println(LPCTSTR strFormat,...);
	CString processString(CString text);
	int getEndLastPosition(CString str);
	int getBeginFirstPosition(CString str);
	int hexToDem(CString str);
private:
	HWND gameHwnd;
	BOOL toolEnable;
	HDC hDc;
	BYTE *pix_data;
	int nbyte;
	int bmWidthBytes;
	int pix_width;
	int pix_height;
	int bitmapSize;
};
