
// MemHelperDlg.cpp : ʵļ
//
#include "stdafx.h"
#include "MemHelper.h"
#include "MemHelperDlg.h"
#include "AsmCode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
#pragma hdrstop
// CMemHelperDlg Ի

CMemHelperDlg::CMemHelperDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMemHelperDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_tempHwnd = NULL;
	pGT = NULL;
}

void CMemHelperDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BTN_FWND, m_fwnd);
}

BEGIN_MESSAGE_MAP(CMemHelperDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_HOTKEY()
	ON_WM_CTLCOLOR()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_BTN_READ, &CMemHelperDlg::OnBnClickedBtnRead)
	ON_BN_CLICKED(IDC_BTN_WRITE, &CMemHelperDlg::OnBnClickedBtnWrite)
	ON_EN_SETFOCUS(IDC_EDIT_HWND_VALUE, &CMemHelperDlg::OnEnSetfocusEditHwndValue)
	ON_EN_SETFOCUS(IDC_EDIT_READ_VALUE, &CMemHelperDlg::OnEnSetfocusEditReadValue)
	ON_EN_SETFOCUS(IDC_EDIT_TITLE, &CMemHelperDlg::OnEnSetfocusEditTitle)
	ON_WM_LBUTTONUP()
	ON_WM_NCLBUTTONUP()
	ON_WM_SYSCOMMAND()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_NCMOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_NCLBUTTONUP()
	ON_WM_SYSCOMMAND()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_NCLBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_CHK_READ_HEX, &CMemHelperDlg::OnBnClickedChkReadHex)
	ON_BN_CLICKED(IDC_CHK_WRITE_HEX, &CMemHelperDlg::OnBnClickedChkWriteHex)
	ON_BN_CLICKED(IDC_BTN_READS, &CMemHelperDlg::OnBnClickedBtnReads)
	ON_BN_CLICKED(IDC_BTN_WRITES, &CMemHelperDlg::OnBnClickedBtnWrites)
	ON_EN_SETFOCUS(IDC_EDIT_READ_VALUES, &CMemHelperDlg::OnEnSetfocusEditReadValues)
	ON_EN_SETFOCUS(IDC_EDIT_PROCESS, &CMemHelperDlg::OnEnSetfocusEditProcess)
	ON_BN_CLICKED(IDC_BTN_OTHER, &CMemHelperDlg::OnBnClickedBtnOther)
	ON_BN_CLICKED(IDC_BTN_CAPTURE, &CMemHelperDlg::OnBnClickedBtnCapture)
END_MESSAGE_MAP()


// CMemHelperDlg Ϣ

BOOL CMemHelperDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲

	pGT = new CGameTool;
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ
	pressFbutton = FALSE;
	readHex = FALSE;
	writeHex = FALSE;
	SetDlgItemText(IDC_EDIT_READ_VALUES_SIZE,"32");
	// TODO: ڴӶĳʼ
	/*LOGFONT lf;							//ṹ ڴ漴ʼ
	lf.lfWeight=500;					//=1000
	lf.lfHeight=13;						//߶(ת)=56
	lf.lfWidth=7;                      //(ת߶)=20
	lf.lfUnderline=FALSE;               //»
	lf.lfStrikeOut=FALSE;               //ɾ
	lf.lfItalic=FALSE;				    //б
	lf.lfEscapement=0;					//ʾǶ=0
	lf.lfCharSet=GB2312_CHARSET;        //ʹȱʡַ
	strcpy_s(lf.lfFaceName,sizeof(lf.lfFaceName),"");    //
	m_editFont.CreateFontIndirect(&lf);*/


	CRect rt;//ԴڿΪ171
	GetWindowRect(rt);
	SetWindowPos(NULL,0,0,305,rt.Height(),SWP_SHOWWINDOW|SWP_NOMOVE);
	CenterWindow();
	return TRUE;  // ǽõؼ򷵻 TRUE
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CMemHelperDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CMemHelperDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMemHelperDlg::ClearFocus(int ID)
{
	GetDlgItem(ID)->SetFocus();
	GetDlgItem(ID)->HideCaret();
}

void CMemHelperDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ڴϢ/Ĭֵ
	CDialogEx::OnTimer(nIDEvent);
}


void CMemHelperDlg::OnHotKey(UINT nHotKeyId, UINT nKey1, UINT nKey2)
{
	// TODO: ڴϢ/Ĭֵ
	CDialogEx::OnHotKey(nHotKeyId, nKey1, nKey2);
}


HBRUSH CMemHelperDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  ڴ˸ DC κ
	if (pWnd->GetDlgCtrlID() == IDC_STATIC_AUT)
	{
		pDC->SetTextColor(RGB(0x0,0x0,0xFF));  //ɫ
		//pDC->SelectObject(&m_editFont);
	}
	// TODO:  ĬϵĲ軭ʣ򷵻һ
	return hbr;
}

void CMemHelperDlg::OnClose()
{
	// TODO: ڴϢ/Ĭֵ
	CDialogEx::OnClose();
	if (pGT != NULL)
	{
		delete pGT;
		pGT = NULL;
	}
}


void CMemHelperDlg::OnDestroy()
{
	CDialogEx::OnDestroy();
	// TODO: ڴ˴Ϣ
}


void CMemHelperDlg::OnBnClickedBtnRead()
{
	// TODO: ڴӿؼ֪ͨ
	if (m_tempHwnd)
	{
		DWORD proID;
		GetWindowThreadProcessId(m_tempHwnd,&proID);//ȡID
		HANDLE hProc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,proID);
		if (hProc)
		{
			CString temp;
			GetDlgItemText(IDC_EDIT_READ_ADD,temp);
			DWORD ads_ps = HexToDem(temp);
			DWORD d_value = 0x0;
			BOOL bAccess = FALSE;
			bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);//ȡַ̬
			for(int i=0; i<4; i++)
			{
				//ȡƫ
				GetDlgItemText(IDC_EDIT_READ_OFFSET1+i,temp);
				if (temp == "")continue;//û
				DWORD offset = HexToDem(temp);
				ads_ps = d_value + offset;
				bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);
			}
			if (bAccess)
			{
				CString outValue;
				outValue.Format(readHex?"%0X":"%d",d_value);
				SetDlgItemText(IDC_EDIT_READ_VALUE,outValue);
			}
			else
				MessageBox("ڴȡʧ");
			CloseHandle(hProc);
		}
		else
		{
			MessageBox("̴ʧ");
		}
	}
	else
	{
		MessageBox("ڱδʼ.");
	}
}


void CMemHelperDlg::OnBnClickedBtnWrite()
{
	// TODO: ڴӿؼ֪ͨ
	if (m_tempHwnd)
	{
		DWORD proID;
		GetWindowThreadProcessId(m_tempHwnd,&proID);//ȡID
		HANDLE hProc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,proID);
		if (hProc)
		{
			CString temp;
			GetDlgItemText(IDC_EDIT_READ_ADD,temp);
			DWORD ads_ps = HexToDem(temp);
			DWORD d_value = 0x0;
			BOOL bAccess = FALSE;
			bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);//ȡַ̬
			for(int i=0; i<4; i++)
			{
				//ȡƫ
				GetDlgItemText(IDC_EDIT_READ_OFFSET1+i,temp);
				if (temp == "")continue;//û
				DWORD offset = HexToDem(temp);
				ads_ps = d_value + offset;
				bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);
			}
			if (bAccess)
			{
				CString inValue;
				GetDlgItemText(IDC_EDIT_WRITE_VALUE,inValue);
				if (writeHex)
					d_value = HexToDem(inValue);
				else
					d_value = _ttoi(inValue);
				bAccess = WriteProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);
				if(!bAccess)
					MessageBox("ڴдʧ");
			}
			else
				MessageBox("ڴȡʧ");
			CloseHandle(hProc);
		}
		else
		{
			MessageBox("̴ʧ");
		}
	}
	else
	{
		MessageBox("ڱδʼ.");
	}
}

void CMemHelperDlg::OnBnClickedBtnReads()
{
	// TODO: ڴӿؼ֪ͨ
	if (m_tempHwnd)
	{
		DWORD proID;
		GetWindowThreadProcessId(m_tempHwnd,&proID);//ȡID
		HANDLE hProc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,proID);
		if (hProc)
		{
			CString temp;
			GetDlgItemText(IDC_EDIT_READ_ADD,temp);
			DWORD ads_ps = HexToDem(temp);
			DWORD d_value = 0x0;
			BOOL bAccess = FALSE;
			BOOL hasOffset = FALSE;
			//ȡƫ
			GetDlgItemText(IDC_EDIT_READ_OFFSET1,temp);
			if(temp != "")
				hasOffset = TRUE;//ƫ
			if (hasOffset)
			{
				bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);//ȡַ̬
				for(int i=0; i<4; i++)
				{
					GetDlgItemText(IDC_EDIT_READ_OFFSET1+i,temp);
					if(temp == "")
					{
						//ƫ׼ȡַ
						GetDlgItemText(IDC_EDIT_READ_VALUES_SIZE,temp);
						int size = _ttoi(temp);
						char *pBuf = new char[size];
						bAccess = ReadProcessMemory(hProc,(void*)d_value,pBuf,size,NULL);
						if (bAccess)
						{
							temp.Format("%s",pBuf);
							SetDlgItemText(IDC_EDIT_READ_VALUES,temp);
						}
						else
						{
							MessageBox("ڴȡʧ");
						}
						delete pBuf;
					}
					else
					{
						//ȡƫ
						DWORD offset = HexToDem(temp);
						ads_ps = d_value + offset;
						bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);
					}
				}
			} 
			else
			{
				//ֱӶȡַ
				//ƫ׼ȡַ
				CString temp;
				GetDlgItemText(IDC_EDIT_READ_VALUES_SIZE,temp);
				int size = _ttoi(temp);
				char *pBuf = new char[size];
				bAccess = ReadProcessMemory(hProc,(void*)ads_ps,pBuf,size,NULL);
				if (bAccess)
				{
					temp.Format("%s",pBuf);
					SetDlgItemText(IDC_EDIT_READ_VALUES,temp);
				}
				else
				{
					MessageBox("ڴȡʧ");
				}
				delete pBuf;
			}
			CloseHandle(hProc);
		}
		else
		{
			MessageBox("̴ʧ");
		}
	}
	else
	{
		MessageBox("ڱδʼ.");
	}
}


void CMemHelperDlg::OnBnClickedBtnWrites()
{
	// TODO: ڴӿؼ֪ͨ
	if (m_tempHwnd)
	{
		DWORD proID;
		GetWindowThreadProcessId(m_tempHwnd,&proID);//ȡID
		HANDLE hProc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,proID);
		if (hProc)
		{
			CString temp;
			GetDlgItemText(IDC_EDIT_READ_ADD,temp);
			DWORD ads_ps = HexToDem(temp);
			DWORD d_value = 0x0;
			BOOL bAccess = FALSE;
			BOOL hasOffset = FALSE;
			//ȡƫ
			GetDlgItemText(IDC_EDIT_READ_OFFSET1,temp);
			if(temp != "")
				hasOffset = TRUE;//ƫ
			if (hasOffset)
			{
				bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);//ȡַ̬
				for(int i=0; i<4; i++)
				{
					GetDlgItemText(IDC_EDIT_READ_OFFSET1+i,temp);
					if(temp == "")
					{
						//ƫ׼ȡַ
						GetDlgItemText(IDC_EDIT_WRITE_VALUES,temp);
						char *pBuf = temp.GetBuffer();
						temp.ReleaseBuffer();
						bAccess = WriteProcessMemory(hProc,(void*)d_value,pBuf,strlen(pBuf),NULL);
						if (!bAccess)
							MessageBox("ڴдʧ");
					}
					else
					{
						//ȡƫ
						DWORD offset = HexToDem(temp);
						ads_ps = d_value + offset;
						bAccess = ReadProcessMemory(hProc,(void*)ads_ps,&d_value,4,NULL);
					}
				}
			} 
			else
			{
				//ֱӶȡַ
				//ƫ׼ȡַ
				CString temp;
				GetDlgItemText(IDC_EDIT_WRITE_VALUES,temp);
				char *pBuf = temp.GetBuffer();
				temp.ReleaseBuffer();
				bAccess = WriteProcessMemory(hProc,(void*)ads_ps,pBuf,strlen(pBuf),NULL);
				if (!bAccess)
					MessageBox("ڴдʧ");
			}
			CloseHandle(hProc);
		}
		else
		{
			MessageBox("̴ʧ");
		}
	}
	else
	{
		MessageBox("ڱδʼ.");
	}
}

void CMemHelperDlg::OnEnSetfocusEditHwndValue()
{
	// TODO: ڴӿؼ֪ͨ
	ClearFocus(IDC_EDIT_HWND_VALUE);
}


void CMemHelperDlg::OnEnSetfocusEditReadValue()
{
	// TODO: ڴӿؼ֪ͨ
	ClearFocus(IDC_EDIT_READ_VALUE);
}

void CMemHelperDlg::OnEnSetfocusEditReadValues()
{
	// TODO: ڴӿؼ֪ͨ
	ClearFocus(IDC_EDIT_READ_VALUES);
}

void CMemHelperDlg::OnEnSetfocusEditProcess()
{
	// TODO: ڴӿؼ֪ͨ
	ClearFocus(IDC_EDIT_PROCESS);
}

void CMemHelperDlg::OnEnSetfocusEditTitle()
{
	// TODO: ڴӿؼ֪ͨ
	ClearFocus(IDC_EDIT_TITLE);
}

CString CMemHelperDlg::DecToHex(DWORD d_value)
{
	CString strHec;
	strHec.Format("%0X",d_value);
	return strHec;
}

int CMemHelperDlg::HexToDem(LPCSTR hexStr)
{
	int dem = 0;
	int length  = strlen(hexStr);
	for (int i = 0; i < length; i++)
	{
		dem = dem * 16;
		if ((hexStr[i] <= '9') && (hexStr[i] >= '0')) // 0~9ַ֮
			dem += hexStr[i] - '0';
		else if ((hexStr[i] <= 'F') && (hexStr[i] >= 'A')) // A~Fַ֮
			dem += hexStr[i] - 'A' + 10;
		else if ((hexStr[i] <= 'f') && (hexStr[i] >= 'a')) // a~fַ֮
			dem += hexStr[i] - 'a' + 10;
		else
			return -1; // ʱ-1
	}
	return dem;
}

DWORD CMemHelperDlg::RemoteCall(HWND hwnd,LPVOID mFunc, LPVOID Param, DWORD ParamSize)
{
	if(hwnd == NULL)
	{
		AfxMessageBox("ȳʼھ!");
		return 0;
	}
	HANDLE hProcess;//Զ̾
	LPVOID mFuncAddr;//뺯ڴַ
	LPVOID ParamAddr;//ڴַ
	HANDLE hThread;    //߳̾
	DWORD NumberOfByte; //ֵ
	DWORD d_size = 10240;
	BOOL HasParam = (ParamSize > 0 && Param != NULL);
	//򿪱עĽ̾     
	DWORD processId;
	::GetWindowThreadProcessId(hwnd,&processId);
	hProcess = OpenProcess(PROCESS_ALL_ACCESS,FALSE,processId);
	if(NULL == hProcess || INVALID_HANDLE_VALUE == hProcess)
	{
		AfxMessageBox("̴ʧ");
		return 0;
	}
	//ڴ MEM_COMMITڴMEM_RESERVEڴ
	mFuncAddr = VirtualAllocEx(hProcess,NULL,d_size,MEM_COMMIT|MEM_RESERVE,PAGE_EXECUTE_READWRITE); 
	if(NULL == mFuncAddr)
	{
		AfxMessageBox("ڴʧ");
		return 0;
	}
	if(HasParam)
	{
		ParamAddr = VirtualAllocEx(hProcess,NULL,ParamSize,MEM_COMMIT|MEM_RESERVE,PAGE_EXECUTE_READWRITE);
		if(NULL == ParamAddr)
		{
			AfxMessageBox("ڴʧ");
			if(mFuncAddr)
				VirtualFreeEx(hProcess,mFuncAddr,d_size,MEM_RELEASE);
			VirtualFreeEx(hProcess,ParamAddr,ParamSize,MEM_RELEASE);    
			return 0;
		}
	}
	//дڴ 
	if(!WriteProcessMemory(hProcess,mFuncAddr,mFunc,d_size, &NumberOfByte))
	{    
		VirtualFreeEx(hProcess,mFuncAddr,d_size,MEM_RELEASE); 
		return 0;
	}
	if(HasParam && !WriteProcessMemory(hProcess,ParamAddr,Param,ParamSize, &NumberOfByte))
	{
		VirtualFreeEx(hProcess,ParamAddr,ParamSize,MEM_RELEASE);  
		return 0;
	}
	//Զ߳ 
	hThread = CreateRemoteThread(hProcess, NULL, 0, (LPTHREAD_START_ROUTINE)(mFuncAddr), ParamAddr, 0, &NumberOfByte);
	WaitForSingleObject(hThread, INFINITE);//ȴ1s߳̽
	//ͷڴ 
	VirtualFreeEx(hProcess,mFuncAddr,d_size,MEM_RELEASE);
	if(HasParam)
		VirtualFreeEx(hProcess,ParamAddr,ParamSize,MEM_RELEASE); 
	//ͷԶ̾
	CloseHandle(hThread);
	CloseHandle(hProcess);
	return NumberOfByte;
}

void CMemHelperDlg::SetFButton(BOOL b)
{
	this->pressFbutton = b;
	if(pressFbutton)
		m_fwnd.SetIcon(::LoadIconA(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_ICON2)));
	else
		m_fwnd.SetIcon(::LoadIconA(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_ICON1)));
}

void CMemHelperDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	CDialogEx::OnLButtonUp(nFlags, point);
	if(pressFbutton)
	{
		FindWindowInfo(point);
		::ReleaseCapture();
		SetFButton(FALSE);
	}
}


void CMemHelperDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	CDialogEx::OnLButtonDown(nFlags, point);
	::ClientToScreen(m_hWnd,&point);
	CPoint *p = &point;
	CRect r;
	m_fwnd.GetWindowRect(&r);
	if (p->x>=r.left&&p->x<=r.right&&p->y>=r.top&&p->y<=r.bottom)
	{
		::SetCapture(m_hWnd);
		SetFButton(TRUE);
		//Ϊ
		HINSTANCE ins = AfxGetInstanceHandle();
		HCURSOR cursor = LoadCursorA(ins,MAKEINTRESOURCE(IDC_CURSOR_CROSS));
		SetCursor(cursor);
	}
}

void CMemHelperDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	CDialogEx::OnMouseMove(nFlags, point);
	if (pressFbutton)
		FindWindowInfo(point);
}


void CMemHelperDlg::FindWindowInfo(CPoint &point)
{
	::ClientToScreen(m_hWnd,&point);
	m_tempHwnd = ::WindowFromPoint(point);
	if (m_tempHwnd)
	{
		char title[256];
		::GetWindowText(m_tempHwnd,title,sizeof(title));
		SetDlgItemText(IDC_EDIT_TITLE,(LPCTSTR)title);
		CString hexStr;
		hexStr.Format("%08X",m_tempHwnd);
		SetDlgItemText(IDC_EDIT_HWND_VALUE,hexStr);
		DWORD dwProcessID;
		GetWindowThreadProcessId(m_tempHwnd,&dwProcessID);
		hexStr;
		hexStr.Format("%08X",dwProcessID);
		SetDlgItemText(IDC_EDIT_PROCESS,hexStr);
		pGT->setGameHwnd(m_tempHwnd);
	}
}

void CMemHelperDlg::OnBnClickedChkReadHex()
{
	// TODO: ڴӿؼ֪ͨ
	if (IsDlgButtonChecked(IDC_CHK_READ_HEX) == BST_CHECKED)
	{
		readHex = TRUE;
		CString text;
		GetDlgItemText(IDC_EDIT_READ_VALUE,text);
		DWORD d_value = _ttoi(text);
		SetDlgItemText(IDC_EDIT_READ_VALUE,DecToHex(d_value));
	}
	else
	{
		readHex = FALSE;
		CString text;
		GetDlgItemText(IDC_EDIT_READ_VALUE,text);
		DWORD d_value = HexToDem(text);
		text.Format("%d",d_value);
		SetDlgItemText(IDC_EDIT_READ_VALUE,text);
	}
}


void CMemHelperDlg::OnBnClickedChkWriteHex()
{
	// TODO: ڴӿؼ֪ͨ
	if (IsDlgButtonChecked(IDC_CHK_WRITE_HEX) == BST_CHECKED)
		writeHex = TRUE;
	else
		writeHex = FALSE;
}



void CMemHelperDlg::OnBnClickedBtnOther()
{
	// TODO: ڴӿؼ֪ͨ
	CRect rt;//ԴڿΪ171
	GetWindowRect(rt);
	int width = rt.Width();
	if(width == 305)
	{
		SetWindowPos(NULL,0,0,rt.Width()+200,rt.Height(),SWP_SHOWWINDOW|SWP_NOMOVE);
		SetDlgItemText(IDC_BTN_OTHER,"<");
	}
	else
	{
		SetWindowPos(NULL,0,0,rt.Width()-200,rt.Height(),SWP_SHOWWINDOW|SWP_NOMOVE);
		SetDlgItemText(IDC_BTN_OTHER,">");
	}
}


void CMemHelperDlg::OnBnClickedBtnCapture()
{
	// TODO: ڴӿؼ֪ͨ
	if(pGT->getGameHwnd() == NULL)
	{
		MessageBox("ھδʼ");
		return;
	}
	pGT->captureScreen();
}
